Loading...
Searching...
No Matches
Opm::NullMaterial< TraitsT > Class Template Reference

Implements a dummy linear saturation-capillary pressure relation which just disables capillary pressure. More...

`#include <NullMaterial.hpp>`

Inheritance diagram for Opm::NullMaterial< TraitsT >:

## Public Types

typedef TraitsT | Traits
typedef NullMaterialParams< TraitsT > | Params
typedef Traits::Scalar | Scalar

## Static Public Member Functions

template<class ContainerT, class FluidState>
static void | capillaryPressures (ContainerT &values, const Params &, const FluidState &)
| Returns constant 0 for all phases.
template<class ContainerT, class FluidState>
static void | saturations (ContainerT &, const Params &, const FluidState &)
| The inverse of the capillary pressure.
template<class ContainerT, class FluidState>
static void | relativePermeabilities (ContainerT &values, const Params &, const FluidState &fluidState)
| The relative permeability of all phases.
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static std::enable_if<(numPhases >1), Evaluation >::type | pcnw (const Params &, const FluidState &)
| The difference between the pressures of the non-wetting and wetting phase.
template<class Evaluation>
static std::enable_if< numPhases==2, Evaluation >::type | twoPhaseSatPcnw (const Params &, const Evaluation &)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Scalar | Sw (const Params &, const FluidState &)
| Calculate wetting phase saturation given that the rest of the fluid state has been initialized.
template<class Evaluation>
static std::enable_if< numPhases==2, Evaluation >::type | twoPhaseSatSw (const Params &, const Evaluation &)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Scalar | Sn (const Params &, const FluidState &)
| Calculate non-wetting phase saturation given that the rest of the fluid state has been initialized.
template<class Evaluation>
static std::enable_if< numPhases==2, Evaluation >::type | twoPhaseSatSn (const Params &, const Evaluation &)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static std::enable_if<(numPhases >2), Evaluation >::type | Sg (const Params &, const FluidState &)
| Calculate gas phase saturation given that the rest of the fluid state has been initialized.
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static std::enable_if<(numPhases >1), Evaluation >::type | krw (const Params &, const FluidState &fluidState)
| The relative permability of the wetting phase.
template<class Evaluation>
static std::enable_if< numPhases==2, Evaluation >::type | twoPhaseSatKrw (const Params &, const Evaluation &Sw)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static std::enable_if<(numPhases >1), Evaluation >::type | krn (const Params &, const FluidState &fluidState)
| The relative permability of the liquid non-wetting phase.
template<class Evaluation>
static std::enable_if< numPhases==2, Evaluation >::type | twoPhaseSatKrn (const Params &, const Evaluation &Sw)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static std::enable_if<(numPhases >2), Evaluation >::type | krg (const Params &, const FluidState &fluidState)
| The relative permability of the gas phase.
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static std::enable_if<(Traits::numPhases >2), Evaluation >::type | pcgn (const Params &, const FluidState &)
| The difference between the pressures of the gas and the non-wetting phase.

## Static Public Attributes

static const unsigned | numPhases = Traits::numPhases
| The number of fluid phases.
static const bool | implementsTwoPhaseApi = (numPhases == 2)
| Specify whether this material law implements the two-phase convenience API.
static const bool | implementsTwoPhaseSatApi = (numPhases == 2)
| Specify whether this material law implements the two-phase convenience API which only depends on the phase saturations.
static const bool | isSaturationDependent = true
| Specify whether the quantities defined by this material law are saturation dependent.
static const bool | isPressureDependent = false
| Specify whether the quantities defined by this material law are dependent on the absolute pressure.
static const bool | isTemperatureDependent = false
| Specify whether the quantities defined by this material law are temperature dependent.
static const bool | isCompositionDependent = false
| Specify whether the quantities defined by this material law are dependent on the phase composition.

## Detailed Description

template<class TraitsT>
class Opm::NullMaterial< TraitsT >

Implements a dummy linear saturation-capillary pressure relation which just disables capillary pressure.

## Member Function Documentation

## capillaryPressures()

template<class TraitsT>
template<class ContainerT, class FluidState>

void Opm::NullMaterial< TraitsT >::capillaryPressures | ( | ContainerT & | values,
|  | const Params & | ,
|  | const FluidState & | )

inline static

Returns constant 0 for all phases.

Parameters

  values | Container for the return values
  params | Parameters
  state | The fluid state

## krg()

template<class TraitsT>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

std::enable_if<(numPhases >2), Evaluation >::type Opm::NullMaterial< TraitsT >::krg | ( | const Params & | ,
|  | const FluidState & | fluidState )

inline static

The relative permability of the gas phase.

This method is only available for at least three fluid phases

## pcgn()

template<class TraitsT>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

std::enable_if<(Traits::numPhases >2), Evaluation >::type Opm::NullMaterial< TraitsT >::pcgn | ( | const Params & | ,
|  | const FluidState & | )

inline static

The difference between the pressures of the gas and the non-wetting phase.

This method is only available for at least three fluid phases

## Sg()

template<class TraitsT>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

std::enable_if<(numPhases >2), Evaluation >::type Opm::NullMaterial< TraitsT >::Sg | ( | const Params & | ,
|  | const FluidState & | )

inline static

Calculate gas phase saturation given that the rest of the fluid state has been initialized.

This method is only available for at least three fluid phases

## Member Data Documentation

## isSaturationDependent

template<class TraitsT>

const bool Opm::NullMaterial< TraitsT >::isSaturationDependent = true

static

Specify whether the quantities defined by this material law are saturation dependent.

In this law, the relative permeabilities are saturation dependent, even if capillary pressure is always zero

The documentation for this class was generated from the following file:

- opm/material/fluidmatrixinteractions/NullMaterial.hpp